
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Shark-0.9.0安装配置运行实践 / iVAN</title>

    <meta name="description" content="Shark-0.9.0安装配置运行实践 Shark(Hive on Spark)是UC Lab为Spark设计并开源的一款数据仓库系统,提供了分布式SQL查询引擎,它能够完全兼容Hive.首先,我们通过下面的图,看一下Shark与Hive的关系(http://shark.cs.berkeley.edu/img/shark-hive-integration.png):以前我们使用Hive分析HDFS中数据时,通过将HQL翻译成MapReduce作业(Job)在Hadoop集群上运行:而使用Shark可以像使用Hive一样容易,如HQL.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Shark-0.9.0安装配置运行实践</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>Shark（Hive on Spark）是UC Lab为Spark设计并开源的一款数据仓库系统，提供了分布式SQL查询引擎，它能够完全兼容Hive。首先，我们通过下面的图，看一下Shark与Hive的关系（http://shark.cs.berkeley.edu/img/shark-hive-integration.png）：<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29zcy5hbGl5dW5jcy5jb20veXFmaWxlcy8xNjg3YmZlMjQ2OWMwYzhhNTdiZmU0OTFkNDM3ODJhOTNiNTkyZWVhLnBuZw==.jpg">以前我们使用Hive分析HDFS中数据时，通过将HQL翻译成MapReduce作业（Job）在Hadoop集群上运行；而使用Shark可以像使用Hive一样容易，如HQL、Metastore、序列化格式、UDF等Shark都支持，不同的是Shark运行在Spark集群上执行计算，基于Spark系统所使用的RDD模型。官方文档给出的性能方面的数据是，使用Shark查询分析HDFS数据，能比Hive快30多倍，如图所示（http://shark.cs.berkeley.edu/img/perf.png）：<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL29zcy5hbGl5dW5jcy5jb20veXFmaWxlcy81MWE2NDdlMjI4NzBiNWI5OGNmYTVlZTU3NjI5Mjk3NGQ2NzkwNTYzLnBuZw==.jpg"><br />
<br />下面，我们通过安装配置Shark来简单地体验一下。</p>
<p><strong>准备软件包</strong></p>
<ul>
<li>jdk-7u25-linux-x64.tar.gz</li>
<li>scala-2.10.3.tgz</li>
<li>apache-maven-3.2.1-bin.tar.gz</li>
<li>hadoop-1.2.1.tar.gz</li>
<li>spark-0.9.0-incubating-bin-hadoop1.tgz</li>
<li>hive-0.11-shark-0.9.0.tar.gz</li>
</ul>
<p><strong>环境变量配置</strong></p>
<p>针对上述准备软件包，我们需要安装配置好JDK、Scala环境，保证Hadoop集群能够正常启动运行，同时Hive也能够执行正确地查询分析工作</p>
<table>
<tbody>
<tr>
<td><code>01</code></td>
<td>
<code>export</code> <code>JAVA_HOME=/usr/java/jdk1.7.0_25/</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>02</code></td>
<td>
<code>export</code> <code>PATH=$PATH:$JAVA_HOME/bin</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>03</code></td>
<td>
<code>export</code> <code>CLASSPATH=$JAVA_HOME/lib/*.jar:$JAVA_HOME/jre/lib/*.jar</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>04</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>05</code></td>
<td>
<code>export</code> <code>SCALA_HOME=/usr/scala/scala-2.10.3</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>06</code></td>
<td>
<code>export</code> <code>PATH=$PATH:$SCALA_HOME/bin</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>07</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>08</code></td>
<td>
<code>export</code> <code>MAVEN_HOME=/home/shirdrn/cloud/programs/apache-maven-3.2.1</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>09</code></td>
<td>
<code>export</code> <code>PATH=$PATH:$MAVEN_HOME/bin</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>10</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>11</code></td>
<td>
<code>export</code> <code>HADOOP_HOME=/home/shirdrn/cloud/programs/hadoop-1.2.1</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>12</code></td>
<td>
<code>export</code> <code>PATH=$PATH:$HADOOP_HOME/bin</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>13</code></td>
<td>
<code>export</code> <code>HADOOP_LOG_DIR=/home/shirdrn/cloud/storage/hadoop-1.2.1/logs</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>14</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>15</code></td>
<td>
<code>export</code> <code>HIVE_HOME=/home/shirdrn/cloud/programs/hive-0.11-shark-0.9.0</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>16</code></td>
<td>
<code>export</code> <code>PATH=$PATH:$HIVE_HOME/bin</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>17</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>18</code></td>
<td>
<code>export</code> <code>SPARK_HOME=/home/shirdrn/cloud/programs/spark-0.9.0-incubating-bin-hadoop1</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>19</code></td>
<td>
<code>export</code> <code>PATH=$PATH:$SPARK_HOME/bin</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>20</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>21</code></td>
<td>
<code>export</code> <code>SHARK_HOME=/home/shirdrn/cloud/programs/shark-0.9.0</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>22</code></td>
<td>
<code>export</code> <code>PATH=$PATH:$SHARK_HOME/bin</code>
</td>
</tr>
</tbody>
</table>
<p><strong>Hive安装配置</strong></p>
<p>这里，我们使用一个用来与Shark进行整合而开发的版本的Hive软件包，可以在这里https://github.com/amplab/hive/releases选择对应的版本。<br />
例如，在主节点m1上准备Hive的软件包：</p>
<table>
<tbody>
<tr>
<td><code>1</code></td>
<td>
<code>wget <a href="https://github.com/amplab/hive/archive/v0.11-shark-0.9.0." rel="external nofollow noreferrer">https://github.com/amplab/hive/archive/v0.11-shark-0.9.0.</a></code><code>tar</code><code>.gz</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>2</code></td>
<td>
<code>mv</code> <code>v0.11-shark-0.9.0 hive-0.11-shark-0.9.0.</code><code>tar</code><code>.gz</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>3</code></td>
<td>
<code>tar</code> <code>xvzf hive-0.11-shark-0.9.0.</code><code>tar</code><code>.gz</code>
</td>
</tr>
</tbody>
</table>
<p>然后修改Hive的配置文件，指定在HDFS上的目录即可，如下所示：</p>
<table>
<tbody>
<tr>
<td><code>01</code></td>
<td>
<code>&lt;?</code><code>xml</code> <code>version</code><code>=</code><code>"1.0"</code><code>?&gt;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>02</code></td>
<td>
<code>&lt;?</code><code>xml-stylesheet</code> <code>type</code><code>=</code><code>"text/xsl"</code> <code>href</code><code>=</code><code>"configuration.xsl"</code><code>?&gt;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>03</code></td>
<td> </td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>04</code></td>
<td>
<code>&lt;</code><code>configuration</code><code>&gt;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>05</code></td>
<td>
<code>&lt;</code><code>property</code><code>&gt;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>06</code></td>
<td>
<code> </code><code>&lt;</code><code>name</code><code>&gt;hive.metastore.warehouse.dir&lt;/</code><code>name</code><code>&gt;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>07</code></td>
<td>
<code> </code><code>&lt;</code><code>value</code><code>&gt;/hive&lt;/</code><code>value</code><code>&gt;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>08</code></td>
<td>
<code> </code><code>&lt;</code><code>description</code><code>&gt;location of default database for the warehouse&lt;/</code><code>description</code><code>&gt;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>09</code></td>
<td>
<code>&lt;/</code><code>property</code><code>&gt;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>10</code></td>
<td>
<code>&lt;/</code><code>configuration</code><code>&gt;</code>
</td>
</tr>
</tbody>
</table>
<p>简单使用这样配置即可。</p>
<p><strong>安装配置Shark</strong></p>
<p>由于我之前先安装配置了Spark-0.9.0，没有找到对应版本的Shark（只找到了Shark-0.8.1的编译包），所以直接从github下载Shark-0.9.0分支的源码，使用sbt进行构建，执行如下命令行：</p>
<table>
<tbody>
<tr>
<td><code>1</code></td>
<td><code>git clone <a href="https://github.com/amplab/shark.git" rel="external nofollow noreferrer">https://github.com/amplab/shark.git</a> -b branch-0.9.0 shark-0.9.0</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>2</code></td>
<td>
<code>cd</code> <code>shark-0.9.0</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>3</code></td>
<td><code>sbt/sbt package</code></td>
</tr>
</tbody>
</table>
<p>上面最后一步使用sbt构建的过程可能需要下载很多依赖包，等待的时间比较长。构建成功之后，可以修改Shark的配置文件：</p>
<table>
<tbody>
<tr>
<td><code>1</code></td>
<td>
<code>cd</code> <code>shark-0.9.0/conf</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>2</code></td>
<td>
<code>mv</code> <code>shark-</code><code>env</code><code>.sh.template shark-</code><code>env</code><code>.sh</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>3</code></td>
<td>
<code>mv</code> <code>log4j.properties.template log4j.properties</code>
</td>
</tr>
</tbody>
</table>
<p>然后修改shark-env.sh，修改内容如下所示：</p>
<table>
<tbody>
<tr>
<td><code>1</code></td>
<td>
<code>export</code> <code>SHARK_MASTER_MEM=512m</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>2</code></td>
<td>
<code>export</code> <code>SPARK_MEM=512m</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>3</code></td>
<td>
<code>export</code> <code>SCALA_HOME=/usr/scala/scala-2.10.3</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>4</code></td>
<td>
<code>export</code> <code>HIVE_CONF_DIR=/home/shirdrn/cloud/programs/hive-0.11-shark-0.9.0/conf</code>
</td>
</tr>
</tbody>
</table>
<p>编译构建并配置Shark，就可以启动Shark Shell，类似Hive Shell一样，执行HQL。</p>
<p><strong>验证Shark</strong></p>
<p>首先，需要启动Hadoop和Spark集群。<br />
启动Shark可以执行如下明命令：</p>
<table>
<tbody>
<tr>
<td><code>1</code></td>
<td><code>bin/shark</code></td>
</tr>
</tbody>
</table>
<p>这样就进入了Shark的Shell环境，类似于Hive。现在，我们可以通过如下一个简单的例子来验证Shark，如下所示：</p>
<table>
<tbody>
<tr>
<td><code>1</code></td>
<td>
<code>CREATE</code> <code>DATABASE</code> <code>user_db;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>2</code></td>
<td>
<code>CREATE</code> <code>TABLE</code> <code>users (login STRING, </code><code>password</code> <code>STRING, id </code><code>INT</code><code>, </code><code>group</code> <code>INT</code><code>, </code><code>user</code> <code>STRING, home STRING, cmd STRING) ROW FORMAT DELIMITED FIELDS TERMINATED </code><code>BY</code> <code>':'</code> <code>LINES TERMINATED </code><code>BY</code> <code>'\n'</code><code>;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>3</code></td>
<td>
<code>LOAD</code> <code>DATA </code><code>LOCAL</code> <code>INPATH </code><code>'/etc/passwd'</code> <code>INTO</code> <code>TABLE</code> <code>users;</code>
</td>
</tr>
</tbody>
</table>
<p>对应于本地Unix系统的/etc/passwd文件，我们创建了一个数据库user_db，然后在该数据库中创建了一个users表，最后将本地/etc/passwd文件上传到HDFS，作为Hive表数据。<br />
执行查询：</p>
<table>
<tbody>
<tr>
<td><code>1</code></td>
<td>
<code>SELECT</code> <code>* </code><code>FROM</code> <code>users;</code>
</td>
</tr>
</tbody>
</table>
<p>验证结果示例如下：</p>
<table>
<tbody>
<tr>
<td><code>01</code></td>
<td>
<code>shark&gt; SELECT * FROM </code><code>users</code><code>;</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>02</code></td>
<td><code>223.128: [Full GC 99467K-&gt;25184K(506816K), 0.1482850 secs]</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>03</code></td>
<td><code>OK</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>04</code></td>
<td>
<code>root x 0 0 root /root /bin/</code><code>bash</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>05</code></td>
<td><code>bin x 1 1 bin /bin /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>06</code></td>
<td><code>daemon x 2 2 daemon /sbin /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>07</code></td>
<td><code>adm x 3 4 adm /var/adm /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>08</code></td>
<td><code>lp x 4 7 lp /var/spool/lpd /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>09</code></td>
<td>
<code>sync</code>  <code>x 5 0  </code><code>sync</code>  <code>/sbin /bin/</code><code>sync</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>10</code></td>
<td>
<code>shutdown</code>  <code>x 6 0  </code><code>shutdown</code>  <code>/sbin /sbin/</code><code>shutdown</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>11</code></td>
<td><code>halt x 7 0 halt /sbin /sbin/halt</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>12</code></td>
<td><code>mail x 8 12 mail /var/spool/mail /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>13</code></td>
<td><code>uucp x 10 14 uucp /var/spool/uucp /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>14</code></td>
<td><code>operator x 11 0 operator /root /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>15</code></td>
<td><code>games x 12 100 games /usr/games /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>16</code></td>
<td><code>gopher x 13 30 gopher /var/gopher /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>17</code></td>
<td>
<code>ftp</code>  <code>x 14 50 FTP User /var/</code><code>ftp</code>  <code>/sbin/nologin</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>18</code></td>
<td><code>nobody x 99 99 Nobody / /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>19</code></td>
<td><code>dbus x 81 81 System message bus / /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>20</code></td>
<td><code>usbmuxd x 113 113 usbmuxd user / /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>21</code></td>
<td><code>avahi-autoipd x 170 170 Avahi IPv4LL Stack /var/lib/avahi-autoipd /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>22</code></td>
<td><code>vcsa x 69 69 virtual console memory owner /dev /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>23</code></td>
<td><code>rtkit x 499 497 RealtimeKit /proc /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>24</code></td>
<td><code>abrt x 173 173 /etc/abrt /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>25</code></td>
<td><code>haldaemon x 68 68 HAL daemon / /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>26</code></td>
<td>
<code>saslauth x 498 76  </code><code>"Saslauthd user"</code>  <code>/var/empty/saslauth /sbin/nologin</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>27</code></td>
<td><code>postfix x 89 89 /var/spool/postfix /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>28</code></td>
<td><code>ntp x 38 38 /etc/ntp /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>29</code></td>
<td><code>apache x 48 48 Apache /var/www /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>30</code></td>
<td><code>avahi x 70 70 Avahi mDNS/DNS-SD Stack /var/run/avahi-daemon /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>31</code></td>
<td><code>pulse x 497 496 PulseAudio System Daemon /var/run/pulse /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>32</code></td>
<td><code>gdm x 42 42 /var/lib/gdm /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>33</code></td>
<td><code>sshd x 74 74 Privilege-separated SSH /var/empty/sshd /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>34</code></td>
<td><code>tcpdump x 72 72 / /sbin/nologin</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>35</code></td>
<td>
<code>shirdrn x 500 500 Jeff Stone /home/shirdrn /bin/</code><code>bash</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>36</code></td>
<td>
<code>mysql x 27 27 MySQL Server /var/lib/mysql /bin/</code><code>bash</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>37</code></td>
<td><code>Time taken: 2.742 seconds</code></td>
</tr>
</tbody>
</table>
<p>可以在HDFS上查询Hive对应的数据存储位置信息：</p>
<table>
<tbody>
<tr>
<td><code>1</code></td>
<td><code>hadoop fs -lsr /hive</code></td>
</tr>
</tbody>
</table>
<p>示例如下所示：</p>
<table>
<tbody>
<tr>
<td><code>1</code></td>
<td><code>[shirdrn@m1 hive-0.11-shark-0.9.0]$ hadoop fs -lsr /hive</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>2</code></td>
<td><code>drwxr-xr-x - shirdrn supergroup 0 2014-03-16 06:06 /hive/user_db.db</code></td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>3</code></td>
<td>
<code>drwxr-xr-x - shirdrn supergroup 0 2014-03-16 06:07 /hive/user_db.db/</code><code>users</code>
</td>
</tr>
</tbody>
</table>
<table>
<tbody>
<tr>
<td><code>4</code></td>
<td>
<code>-rw-r--r-- 3 shirdrn supergroup 1567 2014-03-16 06:07 /hive/user_db.db/</code><code>users</code><code>/</code><code>passwd</code>
</td>
</tr>
</tbody>
</table>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 06:30:06</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Shark-0.9.0安装配置运行实践的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9MxWdBb.html" rel="bookmark">Oozie-3&period;3&period;2安装配置运行实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Oozie是一个开源的工作流调度系统,它能够管理逻辑复杂的多个Hadoop作业,按照指定的顺序将其协同运行起来.例如,我们可能有这样一个需求,某个业务系统每天产生20G原始数据,我们每天都要对其进行处理,处理步骤如下所示: 通过Hadoop先将原始数据同步到HDFS上: 借助MapReduce计算框架对原始数据进行转换,生成的数据以分区表的形式存储到多张Hive表中: 需要对Hive中多个表的数据进行JOIN处理,得到一个明细数据Hive大表: 将明细数据进行复杂的统计分析,得到排序后的报表信息			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/xp86klb.html" rel="bookmark">CssGaga安装配置&colon;运行环境&sol;下载&sol;配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文章简介:CssGaga安装配置:运行环境/下载/配置. 1. 安装Microsoft .NET Framework 3.5 下载 Microsoft .NET Framework 3.5 注:Windows Vista. Windows 7已集成 2. 下载CssGaga最新绿色版并解压到本地 CssGaga Download 3. 更改配置文件CssGaga.exe.config &lt;!-- 本地路径 --&gt; &lt;add key=&quot;pathSource&quot; value=			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0ReE0z.html" rel="bookmark">Hadoop-2&period;2&period;0集群安装配置实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Hadoop 2.x和1.x已经大不相同了,应该说对于存储计算都更加通用了.Hadoop 2.x实现了用来管理集群资源的YARN框架,可以面向任何需要使用基于HDFS存储来计算的需要,当然MapReduce现在已经作为外围的插件式的计算框架,你可以根据需要开发或者选择合适的计算框架.目前,貌似对MapReduce支持还是比较好的,毕竟MapReduce框架已经还算成熟.其他一些基于YARN框架的标准也在开发中. YARN框架的核心是资源的管理和分配调度,它比Hadoop 1.x中的资源分配的粒度			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNv4DoM.html" rel="bookmark">ElasticSearch-2&period;0&period;0集群安装配置与API使用实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ElasticSearch是基于全文搜索引擎库Lucene构建的分布式搜索引擎,我们可以直接使用ElasticSearch实现分布式搜索系统的搭建与使用,都知道,Lucene只是一个搜索框架,它提供了搜索引擎操作的基本API,如果要实现一个能够使用的搜索引擎系统,还需要自己基于Lucene的API去实现,工作量很大,而且还需要很好地掌握Lucene的底层实现原理. ElasticSearch是一个完整的分布式搜索引擎系统,它的一些基本特性包括如下: 全文检索 提供插件机制,可以共享重用插件的功能			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGwe26z.html" rel="bookmark">window7下Tomcat7&period;0安装配置方法&lowbar;Tomcat</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				因为已经安装过jdk1.6,并且jdk的环境变量已经配置完成. 下面主要讲述Tomcat7.0的安装过程: 1.首先在http://tomcat.apache.org/download-70.cgi中下载&quot;32-bit/64-bit Windows Service Installer&quot; 1).一直下一步,中间需要选择安装路径和 JVM 目录,如果JDK和JRE安装没问题,这里他应该能自动找得到,否则需要你手动指定一下. 中间什么也不用管,有一部让你设置端口,不用动,保持默认的就行了.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnwr3Wz.html" rel="bookmark">如何安装配置Apache中的mod&lowbar;security和mod&lowbar;evasive&lpar;1&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				网站服务器安全是个大话题;说到什么是加固某一台网站服务器的最佳工具和技术,不同的人自有不同的偏好和观点.就Apache网站服务器而言,即便不是所有专家,至少也是绝大多数专家一致 认为,mod_security和mod_evasive是两个非常重要的模块,可以保护Apache网站服务器远离常见的威胁.我们在本文中将探讨如何安装及配置mod_security和mod_evasive,假设Apache HTTP网站服务器已经搭建并运行起来.我们将执行演示性质的 压力测试,看看该网站服务器在遇到拒绝服务			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqRynYp.html" rel="bookmark">Linux Tomcat 6&period;0安装配置实践总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				系统环境: Red Hat Enterprise Linux Server release 5.7 (Tikanga)  64位 Tomcat下载 从官方网站 http://tomcat.apache.org/下载你需要的Tomcat版本,目前Tomcat主要版本有Tomcat 6.0.Tomcat 7.0.Tomcat 8.0三个版本,下面我们以6.0(6.0.39)版本为例, 下载URL地址:http://tomcat.apache.org/download-60.cgi ,如果你需要下载T			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/badGLgz.html" rel="bookmark">CentOS 7&period;0安装配置LAMP服务器&lpar;Apache&plus;PHP&plus;MariaDB&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文 CentOS 7.0安装配置LAMP服务器(Apache+PHP+MariaDB)     一.配置防火墙,开启80端口.3306端口 CentOS 7.0默认使用的是firewall作为防火墙,这里改为iptables防火墙. 1.关闭firewall: systemctl stop firewalld.service #停止firewall systemctl disable firewalld.service #禁止firewall开机启动 2.安装iptables防火墙 yum i			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwW8vnz.html" rel="bookmark">Tomcat7&period;0安装配置详细&lpar;图文&rpar;&lowbar;Tomcat</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 说明:Tomcat服务器上一个符合J2EE标准的Web服务器,在tomcat中无法运行EJB程序,如果要运行可以选择能够运行EJB程序的容器WebLogic,WebSphere,Jboss等 Tomcat的下载: http://tomcat.apache.org/  1.进入上面的网站然后如下操作使用Window Service Installer(为Window 添加服务) 2.然后我们进行安装 说明一下: 以前的版本是没有关于Role的设定,到了7.0的时候就有有关的设定,这也说明Tomc			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKkvZb.html" rel="bookmark" class="title">MathType标签栏中的符号如何添加快捷方式</a>
					<div>
						  MathType标签栏中的符号如何添加快捷方式 1.按照自己的使用习惯打开MathType公式编辑器,进入到公式编辑界面. 打开软件进入编辑状态 2.进入到编辑界面后,用鼠标点击MathType中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zG3Bez.html" rel="bookmark" class="title">动易CMS不符合WEB标准的地方&lpar;未完成&rpar;</a>
					<div>
						web|web标准 前天QQ上有位朋友问我,为什么&quot;网页标准化&quot;却不标准?我回答:因为CMS不标准.当然,在我检查首页页面的时候我同样也发现了自己所书写的不符合WEB标准的代码.今 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1kkdz.html" rel="bookmark" class="title">浅谈在openSUSE下ASP&period;NET 4开发环境配置&lpar;1&rpar;</a>
					<div>
						浅谈在openSUSE下ASP.NET 4开发环境配置(1)					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJGK8b.html" rel="bookmark" class="title">详解：如何在&period;NET中访问MySQL数据库？</a>
					<div>
						如果你不是只在大集团公司工作过的话,你一定会有机会接触到MySQL,虽然它并不支持事务处理,存储过程,但是它提供的功能一定能满足你的大部分需求,另外,简洁的MySQL也有一些它独到的优势,在有些时候, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWoEeM.html" rel="bookmark" class="title">JavaScript教程--从入门到精通&lpar;3&rpar;</a>
					<div>
						javascript|教程 JavaScript程序构成 JavaScript脚本语言的基本构成是由控制语句.函数.对象.方法.属性等,来实现编程的. 一.程序控制流 在任何一种语言中,程序控制流是必 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMRA28b.html" rel="bookmark" class="title">SQL SERVER 的函数</a>
					<div>
						server|函数 1.字符串函数 长度与分析用 datalength(Char_expr) 返回字符串包含字符数,但不包含后面的空格 substring(expression,start,lengt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/apX7nlM.html" rel="bookmark" class="title">不要以做关键词排名为目的而去发外链</a>
					<div>
						一个网站想要获得好的排名,就离不开外链和内容!毕竟互联网上的那些SEOer天天喊着&quot;内容为王&quot;&quot;外链为皇&quot;之类的口号,就算不会SEO的人看到这些信息也会知道,原 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVnDAmz.html" rel="bookmark" class="title">使用VisualStudio2010从分析到实施（2）&mdash;使用Activity Diagram提炼业务流程</a>
					<div>
						前言 众所周知VisualStudio 2010在软件开发周期的各个环节上都下了很多功夫,本篇继续前文,向大家介绍使用VisualStudio 2010中对Activity Diagram的支持,和使 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDA3ylb.html" rel="bookmark" class="title">Oracle的联机分析处理（OLAP）</a>
					<div>
						联机分析处理 (OLAP) 的概念最早是由关系数据库之父E.F.Codd于1993年提出的,他同时提出了关 于OLAP的12条准则.OLAP的提出引起了很大的反响,OLAP作为一类产品同联机事务处理  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1AB7z.html" rel="bookmark" class="title">ps怎么给照片添加不规则倒影&quest;</a>
					<div>
						ps怎么给照片添加不规则倒影?   1.打开Photoshop软件并准备好我们的素材.如图所示: 2.打开素材图片,如图所示: 3.使用区域选择工具在不规则倒影处选择大概的区域范围.如图所示: 4.复 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1ReRjp.html" rel="bookmark" class="title">利用窗体域和书签计算试卷总分</a>
					<div>
						在一份试卷中,会有多道题目,每道题目的分值又各不同,如何快速计算所有题目的总分呢?,大家都知道在电子表格里可以方便的进行计算,其实在wps文字里也可以用公式对表格进行计算,但每道题的分值并没有在表格里 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ooJWb.html" rel="bookmark" class="title">win7系统时间怎么调总是不对如何解决？</a>
					<div>
						win7系统时间怎么调总是不对如何解决?   一.电脑时间总是不对的原因 1.可能是CMOS电池没电了,请更换电池. 2.如果电池是新换的或更换没有多少时间,可能是CMOS电池接触不良引起的,如果是, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZZ0vz.html" rel="bookmark" class="title">JavaScript实现在标题栏上显示当前日期的方法</a>
					<div>
						 这篇文章主要介绍了JavaScript实现在标题栏上显示当前日期的方法,涉及javascript操作时间及DOM节点的技巧,非常具有实用价值,需要的朋友可以参考下     本文实例讲述了JavaSc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLam4Az.html" rel="bookmark" class="title">怎样让电脑自动更换桌面背景</a>
					<div>
						Windows 7支持多张桌面背景切换的功能让我们的桌面更加绚丽,但是对于喜欢按照文件夹分门别类保存图片的用户来说,在设置桌面背景时如果指定了包含子目录的文件夹,如&quot;wallpaper&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXj0VAb.html" rel="bookmark" class="title">Excel打印工作表上的控件</a>
					<div>
						  一.如果一个或多个控件是 ActiveX 控件,请执行下列操作: 1.确保&quot;开发工具&quot;选项卡可用. 怎样显示&quot;开发工具&quot;选项卡: 单击&quot;Offic ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOa9jqM.html" rel="bookmark" class="title">任务栏&OpenCurlyDoubleQuote;安全删除硬件&rdquo;里出现删除硬盘驱动器C，D怎么去掉</a>
					<div>
						平时在使用电脑时,常常会在任务栏&quot;安全删除硬件&quot;里出现删除硬盘驱动器C,D,E,F和光驱,本教程就为大家提供解决方法. 故障现象: 任务栏&quot;安全删除硬件&quot;里出现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYRqa9p.html" rel="bookmark" class="title">PostgreSQL cluster&lowbar;name特性（适用多实例场景）</a>
					<div>
						    在一些场景下,需要在一台服务器上运行多个数据库实例,可以通过cluster_name参数设置进程的标示,这样的话在系统中查看多个运行的PG实例的时候,可以通过进程前的cluster_name区 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7BJNM.html" rel="bookmark" class="title">Codeigniter&lpar;CI&rpar;框架分页函数及相关知识&lowbar;php实例</a>
					<div>
						一般在数据分页的时候需要获取当前页的数据和总条数,一般人是在model中封装两个函数分别获取当前页的数据和数据总条数,业务逻辑类似,感觉有点冗余,可以封装在一起: 复制代码 代码如下: /**     ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0QdGPp.html" rel="bookmark" class="title">个人 Wiki 之殇</a>
					<div>
						我一直都在寻找一种优雅的方式来管理我的知识.如果能够优雅地分享,那是最好不过.为此,我先后尝试了 Wiki,Evernote,Blog 等各种媒介. 大三那年,学习了冯志勇教授讲授的&lt;知识工程& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZwA4b.html" rel="bookmark" class="title">南海！南海！这就是我们誓死捍卫的南海！</a>
					<div>
						南海很大,容得下十艘航母N个大国 南海很小,容不下他国一粒子弹! 别在我家门口惹事! 我们热血沸腾,誓死也要保卫的南海 它到底有多美?小编今天就来告诉你! 南海简历 名称:中国南海 英文名:The S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2nOjb.html" rel="bookmark" class="title">何去何从</a>
					<div>
						问题描述 不知不觉已经工作快两年了,此时,感觉如此的颓废,没目标,没斗志,不知道自己该往哪个方向走,所以,想在这里问问大家,听听大家的意见.作为一个程序媛,但是工作量很小,大部分的时间都是自己安排,所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxYQ4mp.html" rel="bookmark" class="title">SQL Server内建SQLDiag工具程序的使用</a>
					<div>
						前言:SQLDiag是SQL Server内建的诊断收集共享程序, [SQL Server 2005]默认位置:C:\Program http://www.aliyun.com/zixun/aggre ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKwaqb.html" rel="bookmark" class="title">求asp&period;net类与对象的论文</a>
					<div>
						问题描述 asp.net求类与对象的论文 解决方案 解决方案二:这东西能写一篇论文出来?classDemo{}//Demo就是类vardemo=newDemo();//demo就是对象 解决方案三:类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRXaGp.html" rel="bookmark" class="title">Windows 10中WiFi密码共享引发安关注</a>
					<div>
						本文讲的是 :  Windows 10中WiFi密码共享引发安关注  ,  [IT168 资讯]随着Windows 10的推出,每一位走入我们家居或者办公环境的陌生人都能够在自己的PC上获取到Wi-F ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQB0VQM.html" rel="bookmark" class="title">【ANDROID游戏开发之二】剖析游戏开发用VIEW还是SURFACEVIEW ？！</a>
					<div>
						本站文章均为 李华明Himi 原创,转载务必在明显处注明:  转载自[黑米GameDev街区] 原文链接: http://www.himigame.com/android-game/295.html  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdyxE3z.html" rel="bookmark" class="title">《IPv6技术精要》一导读</a>
					<div>
						前 言 IPv6技术精要 本书主要讨论IPv6的基础知识.IPv6需要学习的东西很多,而不仅仅是拥有更大的地址空间. 写作本书时,我尽量以一种简单的.步骤式的方法来解释每一个概念,同时将关键细节包含在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX053Ap.html" rel="bookmark" class="title">stl-STL的适配器容器的底层容器如何选择？</a>
					<div>
						问题描述 STL的适配器容器的底层容器如何选择? 比如说实现一个stack结构 它的默认底层容器是deque,但是我们也可以选择用list 和vector, 1 那么需要在什么情况下选择list和ve ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoqDwM.html" rel="bookmark" class="title">急级&period;&period;&period;&period;cxf webservice调用电信短信网关的问题</a>
					<div>
						问题描述 电信提供wsdl地址和参数调用电信的webservicehttp://58.53.194.80/swdx/services/APService?wsdl参数是用户名电话号码什么的.服务端应该 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDk06Xp.html" rel="bookmark" class="title">详解ASP&period;NET MVC的筛选器&lowbar;实用技巧</a>
					<div>
						在ActionInvoker对Action的执行过程中,除了通过利用ActionDescriptor对Action方法的执行,以及之前进行的Model绑定与验证之外,还具有一个重要的工作,那就是对相关 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmZARp.html" rel="bookmark" class="title">学习javascript面向对象 实例讲解面向对象选项卡&lowbar;javascript技巧</a>
					<div>
						本文实例讲解了最简单的面向对象选项卡实现方法,分享给大家供大家参考,具体内容如下 效果图: 1.功能说明 点击三个按钮分别显示对应的选项卡 2.html代码说明 &lt;div class=&quot ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
